<template>
<div :class="class_name" v-on:click="onClick" v-on:mouseover="onHover">
	<slot />
	<div>{{ value }}</div>
	<div class="dropdown">
		<div class="dropdown-list">
			<standard-item
				v-for="option in items"
				v-on:click="onItemClick"
				v-on:hover="onItemHover"
				:id="option.id"
				:key="option.id"
				:selected="option.selected"
			>{{ option.name }}</standard-item>
		</div>
	</div>
</div>
</template>

<script>
import StandardItem from "./StandardItem.vue"

export default {
	components: { StandardItem },
	computed: {
		class_name () {
			return {
				focused: this.focused,
				item: true,
				selected: this.selected
			}
		},
		items () {
			return this.options.map((option, key) => {
				return {
					id: key,
					name: option,
					selected: key === this.current
				}
			})
		}
	},
	created: function () {
		this.closing = false

		this.$on("PRESS_DOWN", () => {
			this.onItemHover(Math.min(this.items.length - 1, this.current + 1))
		})
		this.$on("PRESS_ENTER", () => {
			if (this.focused) {
				this.onItemClick(this.current)
			}
		})
		this.$on("PRESS_UP", () => {
			this.onItemHover(Math.max(0, this.current - 1))
		})
	},
	data () {
		return {
			current: this.options.indexOf(this.value),
			focused: false
		}
	},
	methods: {
		blur () {
			this.focused = false
		},
		onClick () {
			if (!this.closing) {
				this.focused = true
			} else {
				this.closing = false
			}
		},
		onHover () {
			this.$emit("hover", this.id)
		},
		onItemClick (id) {
			this.closing = true
			this.blur()
			this.$emit("change", this.id, id)
			UI.emit("PLAY_CLICK_SOUND")

			window.setTimeout(() => {
				this.closing = false
			}, 10)
		},
		onItemHover (id) {
			if (this.current !== id) {
				UI.emit("PLAY_HOVER_SOUND")
			}
			this.current = id
		}
	},
	name: "dropdown-item",
	props: {
		id: {
			required: true,
			type: Number
		},
		options: {
			required: false,
			type: Array
		},
		selected: {
			default: false,
			type: Boolean
		},
		value: {
			default: "",
			type: String
		}
	}
}
</script>

<style lang="less" src="./styles/Item.less" scoped></style>